# std::tuple<Types...>::swap

From cppreference.com
< cpp‎ | utility‎ | tuple

Defined in header `<tuple>` |  |
void swap( tuple& other ) noexcept(/* see below */); |  | (since C++11) (until C++20)
constexpr void swap( tuple& other ) noexcept(/* see below */); |  | (since C++20)

Calls `swap` (which might be std::swap, or might be found via ADL) for each element in *this and its corresponding element in `other`.

### Parameters

other | - | tuple of values to swap

### Return value

(none)

### Exceptions

`noexcept` specification: noexcept( noexcept(swap( std::declval <T0&>>(), std::declval <T0&>())) && noexcept(swap( std::declval <T1&>>(), std::declval <T1&>())) && noexcept(swap( std::declval <T2&>>(), std::declval <T2&>())) && ... ) In the expression above, the identifier `swap` is looked up in the same manner as the one used by the C++17 std::is_nothrow_swappable trait. | (until C++17)
`noexcept` specification: noexcept( std::is_nothrow_swappable_v <T0> && std::is_nothrow_swappable_v <T1> && std::is_nothrow_swappable_v <T2> && ... ) | (since C++17)

### Example

Run this code

    #include <iostream>
    #include <tuple>
    #include <string>

    int main()
    {
        std::tuple<int, std::string, float> p1, p2;
        p1 = std::make_tuple(10, "test", 3.14);
        p2.swap(p1);
        std::cout << "("  << std::get<0>(p2)
                  << ", " << std::get<1>(p2)
                  << ", " << std::get<2>(p2) << ")\n";
    }

Output:

    (10, test, 3.14)

### Defect reports

The following behavior-changing defect reports were applied retroactively to previously published C++ standards.

DR | Applied to | Behavior as published | Correct behavior
--- | --- | --- | ---
LWG 2456 | C++11 | the `noexcept` specification is ill-formed | made to work

### See also

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/utility/tuple/swap&oldid=107584"